/////////////////////////////////////////////////////////////////////////////
//
//  Soubor: FindFile.cpp
//	
//  (C) 2002 Radek Chalupa
//
/////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <tchar.h>
#include <commctrl.h>
#include <shlobj.h>
#include <shlwapi.h>
#include <stdio.h>

#include "resource.h"

#pragma comment (lib, "comctl32.lib")
#pragma comment (lib, "shlwapi.lib")

void PridejZeSlozky(HWND hWnd, LPTSTR lpSlozka);

/////////////////////////////////////////////////////////////////////////////
// callback procedura pro funkci SHBrowseForFolder

TCHAR chStartBrowseDir[MAX_PATH];

int CALLBACK BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	TCHAR szDir[MAX_PATH];
	switch ( uMsg )
	{
		case BFFM_INITIALIZED:
			if ( chStartBrowseDir != NULL )
				SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)chStartBrowseDir);
			break;
		case BFFM_SELCHANGED:
			if ( SHGetPathFromIDList((LPITEMIDLIST)lParam, szDir))
			{
				SendMessage(hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)szDir);
				PridejZeSlozky((HWND)lpData, szDir);
			}
			break;
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Vyvol dialog vybrn sloky

BOOL VyberSlozku(LPTSTR lpVybranaSlozka, LPCTSTR lpStart, LPCTSTR lpNadpis, HWND hVlastnik)
{
	if ( lpStart != NULL )
		lstrcpy(chStartBrowseDir, lpStart);
	BOOL bResult = TRUE;
	LPITEMIDLIST pidl	= NULL;
	BROWSEINFO bi;
	ZeroMemory(&bi, sizeof(bi));
	LPMALLOC pMalloc = NULL;
	SHGetMalloc(&pMalloc);
	if ( IsWindow(hVlastnik) )
	{
		bi.hwndOwner = hVlastnik;
		bi.lParam = (LPARAM)hVlastnik;
	}
	else
		bi.hwndOwner = NULL;
	bi.pszDisplayName = 0;
	bi.pidlRoot = 0;
	bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	bi.lpfn = BrowseCallbackProc;
	if ( lpNadpis == NULL )
		bi.lpszTitle = _T("Vyberte poadovanou sloku");
	else
		bi.lpszTitle = lpNadpis;
	pidl= SHBrowseForFolder(&bi);
	if ( pidl )
	{
		if ( !SHGetPathFromIDList(pidl, lpVybranaSlozka) )
			bResult = FALSE;
		pMalloc->Free(pidl);
	}
	else
		bResult = FALSE;
	pMalloc->Release();
	return bResult;
}


void PridejSoubor(HWND hListBox, LPWIN32_FIND_DATA lpWFD)
{
	TCHAR szText[MAX_PATH+60];
	TCHAR szVelikost[25];
	TCHAR szCas[25];
	FILETIME fileTime;
	SYSTEMTIME sysTime;
	StrCpy(szText, lpWFD->cFileName);
	StrFormatByteSizeA(lpWFD->nFileSizeLow, szVelikost, sizeof(szVelikost));
	FileTimeToLocalFileTime(&lpWFD->ftLastAccessTime, &fileTime);
	FileTimeToSystemTime(&fileTime, &sysTime);
	_stprintf(szCas, _T("zmnno dne: %d.%d.%d"),
		sysTime.wDay, sysTime.wMonth, sysTime.wYear);
	StrCat(szText, _T(" ( velikost: "));
	StrCat(szText, szVelikost);
	StrCat(szText, _T(", "));
	StrCat(szText, szCas);
	StrCat(szText, _T(" )"));
	SendMessage(hListBox, LB_ADDSTRING, 0, (LPARAM)szText);
}

void PridejZeSlozky(HWND hWnd, LPTSTR lpSlozka)
{
	TCHAR szSoubor[MAX_PATH];
	StrCpy(szSoubor, lpSlozka);
	StrCat(szSoubor, _T("\\*.*"));
	HWND hListBox = GetDlgItem(hWnd, IDC_LISTBOX);
	// Nejprve odstranme ppadn star poloky ListBoxu
	SendMessage(hListBox, LB_RESETCONTENT, 0, 0);
	WIN32_FIND_DATA wfd;
	ZeroMemory(&wfd, sizeof(wfd));
	// Nalezneme 1. objekt
	HANDLE hFind = FindFirstFile(szSoubor, &wfd);
	if ( hFind == INVALID_HANDLE_VALUE )
		return;
	// Vylouit sloky
	if ( !(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) )
		PridejSoubor(hListBox, &wfd);
	// Prochzme vemi objekty ve sloce
	while ( FindNextFile(hFind, &wfd) )
	{
		if ( !(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) )
			PridejSoubor(hListBox, &wfd);
	}
	// Zavt handle vyhledvn
	FindClose(hFind);
}

/////////////////////////////////////////////////////////////////////////////
// Procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static TCHAR szSlozka[MAX_PATH] = _T("d:\\");;
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
				case IDCANCEL:
					EndDialog(hWnd, IDOK);
					break;
				case IDC_PROHLEDAT_SLOZKU:
					VyberSlozku(szSlozka, szSlozka, _T("Vbr sloky"), hWnd);
					break;
			}
			break;
		case WM_INITDIALOG:
			break;
	}
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu pro Windows

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	// Inicializace CommonControls
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icc.dwICC = ICC_WIN95_CLASSES;
	if ( !InitCommonControlsEx(&icc) )
	return -1;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_HLAVNI), NULL, DialogProc);
	return 0;
}

